/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_OBSPADRAO                                                */
/* Tabela : OBSPADRAO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 14/05/2004 - RENATA DINIZ                                                  */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_OBSPADRAO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_OBSPADRAO
GO

CREATE TRIGGER DTULTATU_OBSPADRAO
ON OBSPADRAO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'OBSPADRAO', null, 'CDOBSPADRAO='+ CDOBSPADRAO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE OBSPADRAO
      SET DTULTATUOBSP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(OBSPADRAO.CDOBSPADRAO ,0) = ISNULL(OBSPADRAO.CDOBSPADRAO ,0));
   END;
END;
GO

